"use strict";

const pipe = require("@promistream/pipe");
const map = require("@promistream/map");
const buffer = require("@promistream/buffer");

module.exports = function join(joinValue) {
	let firstValueProcessed = false;

	return pipe([
		map((value) => {
			if (firstValueProcessed === false) {
				firstValueProcessed = true;
				return [ value ];
			} else {
				return [ joinValue, value ];
			}
		}),
		buffer()
	]);
};
